package com.pms.ocp.service;

import com.baomidou.mybatisplus.extension.service.IService;
import com.github.pagehelper.PageInfo;
import com.pms.ocp.model.dto.GroupDto;
import com.pms.ocp.model.dto.OcpTenantBaseDto;
import com.pms.ocp.model.dto.TenantDto;
import com.pms.ocp.model.dto.WholeLinkParamDto;
import com.pms.ocp.model.entity.OcpApiGroup;
import com.pms.ocp.model.entity.OcpTenantBase;
import com.pms.ocp.model.entity.OcpTenantGroup;
import com.pms.ocp.model.vo.OcpApiBaseVo;
import com.pms.ocp.model.vo.ResponseVO;

import java.sql.Timestamp;
import java.util.List;

/**
 * @author guofanfan
 */
public interface TenantBasicManagementService extends IService<OcpTenantBase> {
    /**
     * 条件查询
     * @param tenantCode
     * @param keyword
     * @param tenantUnit
     * @param startTime
     * @param endTime
     * @param pageSize
     * @param pageNum
     * @return
     */
    List<OcpTenantBaseDto> queryOcpTenantBaseDto(String tenantGroupCode,String tenantCode, String keyword, String tenantUnit, Timestamp startTime, Timestamp endTime, Integer pageSize, Integer pageNum);

    /**
     * 应用发布 改变其应用状态
     * @param tenantCodes 应用代码
     * @return
     */
    ResponseVO tenantIssue(String tenantCodes);

    /**
     * 应用订阅
     * @param tenantCodes
     */
    ResponseVO tenantLogin(String tenantCodes,String companyCode);

    /**
     * 下线
     * @param tenantCodes
     * @return
     */
    ResponseVO tenantCancel(String tenantCodes);

    /**
     * 应用注册
     * @param ocpTenantBaseDto
     */
    ResponseVO applyRegister(OcpTenantBaseDto ocpTenantBaseDto);

    /**
     * 应用树层级
     * @param tenantGroupCode
     * @param tenantGroupCompanyCode
     * @return
     */
    List<GroupDto> tenantBaseTreeOther(String tenantGroupCode, String tenantGroupCompanyCode);

    /**
     * 应用列表
     * @param tenantDto
     * @return
     */
    ResponseVO<PageInfo<OcpTenantBaseDto>> getBaseByGroupCode(TenantDto tenantDto);



    /**
     * 应用树底层
     * @param tenantGroupCode
     * @param tenantGroupCompanyCode
     * @return
     */
    List<OcpTenantBase> tenantBaseTree(String tenantGroupCode, String tenantGroupCompanyCode);

    /**
     * 应用注册查询
     * @param tenantGroupCode
     * @param tenantGroupCompanyCode
     * @return
     */
    OcpTenantGroup selectRegister(String tenantGroupCode, String tenantGroupCompanyCode);

    /**
     * 应用树
     * @param tenantGroupCode
     */

}
